#include "Box.hxx"

Box::Box() : m_min(-Infinity), m_max(Infinity)
{
}

Box::~Box()
{
}

Box::Box(const Box& b)
{
  m_min = b.m_min;
  m_max = b.m_max;
}

Box&
Box::operator=(const Box& b)
{
  m_min = b.m_min;
  m_max = b.m_max;
  return *this;
}

void
Box::Clear()
{
}

void
Box::Extend(const Vec3f& a)
{
  // for all three coordinates, move m_max or m_min to the point
  for(size_t i = 0; i < 3; i++) {
    if(a[i] > m_max[i]) {
      m_max[i] = a[i];
    } else if(a[i] < m_min[i]) {
      m_min[i] = a[i];
    } // else: do nothing, coordinate is inside the box
  }
}

void
Box::Extend(const Box& box)
{
}

bool
Box::Overlaps(const Box& b) const
{
  return false;
}

void
Box::Clip(const Ray& ray, float& tnear, float& tfar) const
{
}

const Vec3f&
Box::min() const
{
  return m_min;
}

const Vec3f&
Box::max() const
{
  return m_max;
}
